!subroutine input_parababdcr
! this routine reads MATRA and B from input files
! or using intrinsic random fortran procedure
!%%%%%%%%%%%%%%%%%%%%%%%%%%%
! Compilating Commands
! mpif90 -c -u input_parababdcr4.f90
!%%%%%%%%%%%%%%%%%%%%%%%%%%%

!%%%%%%%%%%%%%%%%%%%%%%%%%%%
! INPUT FILE
!  file 'INPUTMATR'  contains STRUCTA
!  file 'INPUTRHS' contains the  array B=[f;d]
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

SUBROUTINE INPUT_PARABABDCR4(N,M,MATRA,VECTB)

! PURPOSE
! 1) if in calling there is only MATRA then, 
!    the matrix (from input files or from random intrinsic procedure)
!    goes in output parameter MATRA 
! 2) if in calling there is MATRA and VECTB then
!    VECTB is obtained from input files or intrisic random
!    procedure or as sum of columns of MATRA (that is seen as input parameter)


!!!!!!!!!Input variables!!!!!!!!!!!
!  N size of each block Si Ri
!  M number of block rows [Si Ri]
!!!!!!!!!Input files!!!!!!!!!!!!!!!
!!!!!!!!!Output variables!!!!!!!!!
!  B the rhs [f;d]
!  MATRA=[S1,R1, S2, R2,....,S_m, R_m, Ba, Bb, 0]
 USE PRECISION
! USE PARABABDCR_PACKAGE

 !IMPLICIT NONE
 !INTEGER, PARAMETER :: DP=KIND(1.0D0)


 INTEGER,  INTENT(IN) :: N, M
 REAL(DP), OPTIONAL, INTENT(IN OUT):: MATRA(N,N,2*(M+1)+1 )
 REAL(DP), OPTIONAL, INTENT(OUT)   :: VECTB((M+1)*N)
! local variables
 INTEGER :: I, J, K
 CHARACTER :: ANS
 CHARACTER(LEN=20) ::  FILE_NAME


   ANS='0'



!!     IF (PRESENT(VECTB)) THEN
!
!       DO WHILE ((ANS.NE.'r').AND.(ANS.NE.'f').AND.(ANS.NE.'R').AND.(ANS.NE.'F') &
!               .AND.(ANS.NE.'S').AND.(ANS.NE.'s') )
!         PRINT *, 'Input rhs of size ',(M+1)*N,' : random, sum of columns  or from file? (r/s/f)'
!         READ *, ANS
!       ENDDO
!
!     SELECT CASE (ANS)
!       CASE('r', 'R')
!         DO I=1,(M+1)*N
!           CALL RANDOM_NUMBER(VECTB(I))
!         ENDDO
!       CASE('s', 'S')
!          DO I=1,M+1
!            VECTB((I-1)*N+1:I*N)=SUM( MATRA(:,:,2*I-1), DIM=2 )+ &
!                                 SUM( MATRA(:,:,2*I), DIM=2 )
!          ENDDO
!
!       CASE('f', 'F')
!         PRINT *,'Insert the file name that contains the input rhs'
!         READ  *, FILE_NAME
         FILE_NAME='INPUTRHS'
         OPEN (20, FILE=FILE_NAME, STATUS='OLD')
         DO I=1,(M+1)*N
           READ(20,*) VECTB(I)
         ENDDO
         CLOSE(20)
!     END SELECT
!   ELSE
!     !input new MATR_A,...
!
!  !if it was present deallocate it
!  !     IF (PINFO.EQ.1) DEALLOCATE( PMATR_A, PPERM, PFILL_IN )
!
! allocate permanent array of module
!     ALLOCATE( PMATR_A( PNRWBLK, PNRWBLK, (PNBLOKS+1)*2+1 ), &
!               PPERM( (PNRWBLK)*2, PNBLOKS ), &
!               PFILL_IN( PNRWBLK, PNRWBLK, PNBLOKS-1 ) )
!
!
! !  choose random_numbers or input_files
!     DO WHILE ((ANS.NE.'r').AND.(ANS.NE.'f').AND.(ANS.NE.'R').AND.(ANS.NE.'F'))
!       PRINT *, 'Input matrix : random or from file? (r/f)'
!       READ *, ANS
!!     ENDDO
!
!     SELECT CASE (ANS)
!       CASE('r', 'R')
!        DO K=1,2*(M+1)
!         DO J=1,N
!           DO I=1,N
!             CALL RANDOM_NUMBER(MATRA(I,J,K))
!             MATRA(I,J,K)= (MATRA(I,J,K)-0.5)*20
!           ENDDO
!         ENDDO
!        ENDDO
!       CASE('f', 'F')
!         PRINT *,'Insert the file name that contans the input matrix'
!         READ  *, FILE_NAME
         FILE_NAME='INPUTMATR'
         OPEN (10, FILE=FILE_NAME, STATUS='OLD')
         DO K=1,2*(M+1)
          DO J=1,N
           DO I=1,N
             READ(10,*) MATRA(I,J,K)
           ENDDO
          ENDDO
         ENDDO
         CLOSE(10)
         
!     END SELECT
!     IF (N>2) THEN
!       DO WHILE ((ANS.NE.'y').AND.(ANS.NE.'Y').AND.(ANS.NE.'n').AND.(ANS.NE.'N'))
!         PRINT *, 'Input matrix : Transform in ill conditioned(1c+2c in 3c)? (y/n)'
!         READ *, ANS
!       ENDDO
!       IF ((ANS.EQ.'y').OR.(ANS.EQ.'Y')) THEN
!         MATRA(:,3,1)=MATRA(:,1,1)+MATRA(:,2,1)
!         MATRA(:,3,2*M+1)=MATRA(:,1,2*M+1)+MATRA(:,2,2*M+1)
!       ENDIF
!     ENDIF
!
! 
!    ENDIF

  RETURN
END SUBROUTINE INPUT_PARABABDCR4
