!subroutine input_parababdcrg
! this routine reads MATRA and B from input files
! or using intrinsic random fortran procedure

SUBROUTINE INPUT_PARABABDCRG( k,m,NBLOKS,MATRA,VECTB )



!!!!!!!!!!Input variables!!!!!!!!!!!!
!  k,m  determine size of each block, Ai ,Bi,Ci, where
!       Ai is (k+m)xm, Bi is (k+m)xk, Ci is (k+m)xk
!  NBLOKS number of block rows [Ai Bi Ci]
!!!!!!!!!Input files!!!!!!!!!!!!!!!!!
!!!!!!!!!Output variables!!!!!!!!!!!!
!  VECTB the rhs [f;d]
!  MATRA=[A1,B1,C1,A2,B2,C2,....,Am,Bm,Cm,Ba,Bb]
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!  file INPUTSR  contains STRUCTA
!  file INPUTRHS contains the  array B=[f;d]
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

 USE PRECISION
! USE PARABABDCR_PACKAGE

 !IMPLICIT NONE
 !INTEGER, PARAMETER :: DP=KIND(1.0D0)


 INTEGER,  INTENT(IN) :: k, m, NBLOKS
 REAL(DP),  INTENT(IN OUT):: MATRA( (k+m)*(k+m*2)*(NBLOKS)+(m**2)*2 )
 REAL(DP),  INTENT(OUT)   :: VECTB( (k+m)*NBLOKS+m )
! local variables
 INTEGER :: I, J
 CHARACTER :: ANS
 CHARACTER(LEN=20) ::  FILE_NAME


     ANS='0'


 !  choose random_numbers or input_files
     DO WHILE ((ANS.NE.'r').AND.(ANS.NE.'f').AND.(ANS.NE.'R').AND.(ANS.NE.'F'))
       PRINT *, 'Input matrix : random or from file? (r/f)'
       READ *, ANS
     ENDDO

     SELECT CASE (ANS)
       CASE('r', 'R')
         DO I= 1,(k+m)*(k+m*2)*NBLOKS + (m**2)*2
             CALL RANDOM_NUMBER( MATRA(I ))
             MATRA(I)= ( MATRA(I)-0.5 )*20
         ENDDO

       CASE('f', 'F')
         PRINT *,'Insert the file name that contans the input matrix'
         READ  *, FILE_NAME
!         FILE_NAME='INPUTMATR'
         OPEN (10, FILE=FILE_NAME, STATUS='OLD')
         DO I= 1,(k+m)*(k+m*2)*NBLOKS + (m**2)*2
           READ(10,*) MATRA(I,J,K)
         ENDDO
        CLOSE(10)

     END SELECT

     DO WHILE ((ANS.NE.'r').AND.(ANS.NE.'f').AND.(ANS.NE.'R').AND.(ANS.NE.'F') &
               .AND.(ANS.NE.'S').AND.(ANS.NE.'s') )
       PRINT *, 'Input rhs of size ',(k+m)*NBLOKS+m,' : random or from file? (r/f)'
       READ *, ANS
     ENDDO

     SELECT CASE (ANS)
       CASE('r', 'R')
         DO I= 1,(k+m)*NBLOKS+m
           CALL RANDOM_NUMBER(VECTB(I))
         ENDDO

       CASE('f', 'F')
         PRINT *,'Insert the file name that contains the input rhs'
         READ  *, FILE_NAME
!         FILE_NAME='INPUTRHS'
         OPEN (20, FILE=FILE_NAME, STATUS='OLD')
         DO I= 1,(k+m)*NBLOKS+m
           READ(20,*) VECTB(I)
         ENDDO
         CLOSE(20)
     END SELECT


  RETURN
END SUBROUTINE INPUT_PARABABDCRG
