!main4.f90 -The main program for 'effective' parallel version of babdcr with MPI directives
!factorization and solution in the effective cyclic reduction PARABABDCR (fact+sol) 
!with only NBLOKS a power of two 
!%%%%%%% 
! Compilating Commands 
! mpif90 -c -u  paramod4.f90 
! mpif90 -c -u input_parababdcr4.f90 
! mpif90 -mpilog main4.f90 -o main4 paramod4.o input_parababdcr4.o -Llapack77 -lmy 
! 
!%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%% 
! Execution commands  
! mpirun -np 2 -machinefile machine ./main4 
!%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%% 
PROGRAM MAIN4 
 USE PRECISION 
 USE MPI 
 
 USE PARABABDCR_PACKAGE4    
 

  
! USE MPI 
 
  
!MATR , A, XTEO, IPIV, are used  only for the solution control 
!MATR is also used for obtain the rhs=sum of columns of MATR in INPUT_BABDCR 
!this are used only form proc 0 (the root) 
 REAL(DP), ALLOCATABLE :: MATR(:,:,:), VECTB(:,:) 
! INTEGER,  ALLOCATABLE :: IPIV( : ) 
 REAL(DP), ALLOCATABLE :: MYMATR_A( :,:,: ), MYFILL_IN( :,:,: ), MYVECTB( :,: ), & 
 
 !BABB the boundary condition [Ba Bb], 
 !D, the rhs correspondent to the non-separated boundary condition, d 
                          BABB(:,:,:), D(:) 
 INTEGER, ALLOCATABLE:: MYPERM( :,: ), OUT( : ) 
 INTEGER :: NRWBLK, NPROCS, LOGNPROCS, NFORPROC, NGSTEPS, I, K, LENGTHK, LENGTH1, & 
            LENGTHVBK, LENGTHVBK1, P, MYINFO, STAT( MPI_STATUS_SIZE )!, event1a, & 
!            event1b, event2a, event2b, event3a, event3b, EMPTY 
 
 INTEGER, PARAMETER :: MAXNPROCS= 2 
 
 REAL(DP) ::  Q, ERROR, time_begin, time_begindistr, time_afterfact, & 
              time_fact, time_sol 
 INTRINSIC CEILING 
! INTERFACE 
!   SUBROUTINE INPUT_PARABABDCR4(N,M,MATRA,VECTB) 
!     USE PRECISION 
!     INTEGER ,  INTENT(IN) :: N, M 
!     REAL(DP), OPTIONAL, INTENT(IN OUT):: MATRA(N,2*(M+1)*N) 
!     REAL(DP), OPTIONAL, INTENT(OUT):: VECTB((M+1)*N) 
!   END SUBROUTINE INPUT_PARABABDCR4 
! END INTERFACE 
  CALL MPI_INIT( IERR ) 
!  CALL MPE_INIT_LOG 
 
!time in second from some time in the past 
  time_begin= MPI_WTIME() 
! determine rank K of current proc in domain MPI_COMM_WORLD , K= 0,....,NPROCS-1 
  CALL MPI_COMM_RANK( MPI_COMM_WORLD, K, IERR ) 
!!$  event1a= MPE_Log_get_event_number() 
!!$  event1b = MPE_Log_get_event_number() 
!!$  event2a= MPE_Log_get_event_number() 
!!$  event2b = MPE_Log_get_event_number() 
!!$  event3a = MPE_Log_get_event_number() 
!!$  event3b = MPE_Log_get_event_number() 
!!$  ierr = MPE_Describe_state( event1a, event1b, & 
!!$                                   "Bcast bound.cond.", "black" ) 
!!$  ierr = MPE_Describe_state( event2a, event2b, & 
!!$                                   "Scatter MATR", "grey" ) 
!!$  ierr = MPE_Describe_state( event3a, event3b, & 
!                                   "Scatter VECTB", "white" ) 
!  print *,'I''m processor ', K 
!    PRINT *,'Insert the size of each block ' 
!    READ  *, NRWBLK 
    NRWBLK= 4
    print *,'m= ', NRWBLK
!    PRINT *,'Insert the number of block rows ' 
!    READ  *, NBLOKS 
    NBLOKS= 1024 
    print *,'N= ', NBLOKS
    ALLOCATE(BABB(NRWBLK,NRWBLK,2),D(NRWBLK)) 
 
   IF ( K.EQ.0 ) THEN 
    ALLOCATE( MATR( NRWBLK, NRWBLK, (NBLOKS+1)*2+1 ), VECTB( NRWBLK, NBLOKS+1 ) ) 
! fill MATR and VECTB 
    CALL INPUT_PARABABDCR4( NRWBLK, NBLOKS, MATR(1,1,1), VECTB(1,1) ) 
 
!       print *,' MATR= ', MATR 
!    print *,' VECTB= ', VECTB 
  !save the boundary condition Ba, Bb and the rhs d 
    BABB( :,:,1:2 )= MATR( :,:,NBLOKS*2+1:NBLOKS*2+2 ) 

!!!ex!!! 
!    D( : )= VECTB( :,NBLOKS+1 ) 
!!!! 
    D( 1:NRWBLK )=VECTB( 1:NRWBLK, 1) 
 
  ENDIF 
 
! compute NPROCS, NFORPROC, NGSTEPS on all processor - difference respect before 
! in this manner I want save the communication of INDEXMSG 
    Q= NBLOKS/2 
    I= 1 
    DO WHILE ( Q>MAXNPROCS ) 
      Q= CEILING( Q/2 ) 
      I= I+1 
    ENDDO 
    NPROCS= Q 
    NFORPROC= I 
    NGSTEPS= LOGDUE( NBLOKS ) 
    PRINT *,'Optimum choice is ', NPROCS,' processors' 
!determine length of MYMATR_A and MYVECTB in all processor 
! it will contain the initial blocks of MATR(that are 2**NFORPROC) 
! and the block received after the log(NPROCS) point to point communication 
! and the boundary condition (2) and the last block is used for 
! copy the first block and apply the factorization 
    LOGNPROCS= LOGDUE(NPROCS) 
    LENGTHK= (2**NFORPROC)*2 + 2*LOGNPROCS + 3 
    LENGTHVBK= (LENGTHK-1)/2 
 
!allocate MYMATR_A, MYFILL_IN, MYPERM and MYVECTB of  proc K 
    ALLOCATE( MYMATR_A( NRWBLK, NRWBLK, LENGTHK ), & 
              MYFILL_IN( NRWBLK, NRWBLK, (LENGTHK-5)/2 ), & 
              MYPERM( NRWBLK*2, (LENGTHK-3)/2 ), & 
              MYVECTB( NRWBLK, LENGTHVBK ), & 
              OUT(LOGNPROCS) ) 
   time_begindistr= MPI_WTIME() 
!   print *, 'Time begin bcast of Ba Bb from 0 in proc',K, & 
!           'respect begin in sec= ', time_begindistr-time_begin 
!   ierr = MPE_Log_event( event1a, 0, "start bcast Ba Bb and d ") 
     CALL MPI_BCAST(BABB(1,1,1),2*NRWBLK*NRWBLK,MPI_DOUBLE_PRECISION,0,MPI_COMM_WORLD,IERR) 
     CALL MPI_BCAST(D(1),NRWBLK,MPI_DOUBLE_PRECISION,0,MPI_COMM_WORLD,IERR) 
!   ierr = MPE_Log_event( event1b, 0, "end bcast Ba Bb and d") 
 
 
   MYMATR_A(:,:,LENGTHK-2:LENGTHK-1)= BABB(:,:,1:2) 

!!ex!!!! 
!   MYVECTB(:,LENGTHVBK)= D(:) 
!!! 

   MYVECTB(1:NRWBLK,1)=D(1:NRWBLK) 
 
 
   L2=NRWBLK*NRWBLK*2*(2**NFORPROC) 
 
   EMPTY=SPACE(K+1,NPROCS) 
 
!Scatter matr 
  time_begindistr= MPI_WTIME() 
 ! print *, 'Time begin Matr scatter in proc' ,K, 'respect begin in sec= ', time_begindistr-time_begin 
 
!  ierr = MPE_Log_event( event2a, 0, "start scatter MATR") 
  CALL MPI_SCATTER( MATR(1,1,1), L2, MPI_DOUBLE_PRECISION, MYMATR_A(1,1,2*EMPTY+1), & 
                    L2, MPI_DOUBLE_PRECISION,0,MPI_COMM_WORLD,IERR ) 
!  ierr = MPE_Log_event( event2b, 0, "end scatter MATR") 
!  print *,'end scatter matr in proc K', K,'MYMATR_A', MYMATR_A 
 
  L2=L2/(2*NRWBLK) 
!Scatter call 
  time_begindistr= MPI_WTIME() 
 ! print *, 'Time begin VECTB scatter in proc' ,K, 'respect begin in sec= ', time_begindistr-time_begin 
!  ierr = MPE_Log_event( event3a, 0, "start scatter VECTB") 
  CALL MPI_SCATTER( VECTB(1,2), L2, MPI_DOUBLE_PRECISION, MYVECTB(1,EMPTY+2), & 
                    L2, MPI_DOUBLE_PRECISION,0,MPI_COMM_WORLD,IERR ) 
!  ierr = MPE_Log_event( event3b, 0, "end scatter VECTB") 
  
  
! factorization 
!  print *,'Hi there before calling _FACT, I''m proc', K 
! in this _FACT  processor send their blocks factorized and their 
!fill_in and their permutation matrix to proc 0 
  time_begindistr= MPI_WTIME() 
  print *, 'Time before fact in proc',K, & 
           'respect begin in sec= ', time_begindistr-time_begin 
  CALL PARABABDCR_FACT4( K, LENGTHK, LENGTHVBK, NPROCS, LOGNPROCS, NFORPROC, & 
                        NRWBLK, NBLOKS, MYMATR_A(1,1,1), MYPERM(1,1), & 
                        MYFILL_IN(1,1,1), MYINFO, OUT(1) ) 
  time_afterfact= MPI_WTIME() 
  !print *, 'Time after fact in proc',K, & 
  !         'respect begin in sec= ', time_afterfact-time_begin 
  print *,'time of the factorization in ',K,' is', time_afterfact-time_begindistr 
  time_fact= time_afterfact-time_begindistr 
 
 
 
  time_begindistr= MPI_WTIME() 
  !print *, 'Time before sol in proc',K, & 
  !         'respect begin in sec= ', time_begindistr-time_begin 
 
   CALL PARABABDCR_SOLV4( K, LENGTHK, LENGTHVBK, NPROCS, LOGNPROCS, NFORPROC, & 
                          NRWBLK, NBLOKS, MYMATR_A(1,1,1), MYPERM(1,1), & 
                          MYFILL_IN(1,1,1), OUT(1), MYVECTB(1,1) ) 
   time_total= MPI_WTIME() 
  print *, 'Time total in proc',K, & 
           'respect begin, is = ', time_total-time_begin 
  print *, 'time of the solution in ',K,' is', time_total-time_begindistr 
  time_sol= time_total-time_begindistr 
  print *,'tima fact+sol', time_sol+time_fact 
!! control of solution 
    IF (INFO.EQ.0) THEN 
      ERROR= MAXVAL( ABS(1- MYVECTB ) ) 
!      WRITE(*,*)    'NRWBLK= ',NRWBLK,'  NBLOKS= ',NBLOKS,& 
!                 'NPROCS= ',NPROCS 
 
!    WRITE(*,*) 'solution is', MYVECTB 
 
      WRITE(*,*) 'MAX ABS ERROR IN PROCESSOR',K,' is', ERROR 
!    print *, 'xteo=',XTEO 
    ENDIF 
!    DEALLOCATE(A, XTEO, IPIV) 
!  ENDIF 
!! 

!  CALL MPE_FINISH_LOG('main4') 
  CALL MPI_FINALIZE(IERR) 
  DEALLOCATE( MYMATR_A, & 
              MYFILL_IN, MYPERM, & 
              MYVECTB, & 
              OUT ) 
 
  STOP 
  
END PROGRAM MAIN4 
!!!!!!!!!!!!!!!!!!!!!!!!!!!!! 
! solution part --->decomment after... 
!     CASE ('2') 
!       IF (PINFO.EQ.0) THEN 
!          WRITE(*,*) ' Not exist any factorized stored matrix ' 
!       ELSE 
! 
!         ALLOCATE( B( PNRWBLK, PNBLOKS+1 ) ) 
!         CALL INPUT_BABDCR( PNRWBLK, PNBLOKS, MATRA=MATR, VECTB=B ) 
! 
!!!control solution 
!!allocate used vectors in control solution part 
!         ALLOCATE( A( PNRWBLK*(PNBLOKS+1), & 
!                   PNRWBLK*(PNBLOKS+1) ), & 
!                   XTEO( PNRWBLK, PNBLOKS+1 ), & 
!                   IPIV( PNRWBLK*(PNBLOKS+1) ) ) 
!!initialize XTEO and A 
!         A=0 
!         XTEO= B 
!!computation of theoretical solution 
!         CALL MATR_ASSEMBL( PNRWBLK, PNBLOKS, MATR, A ) 
! 
!         CALL DGETRF( PNRWBLK*(PNBLOKS+1), PNRWBLK*(PNBLOKS+1), A, & 
!                      PNRWBLK*(PNBLOKS+1), IPIV, INFO ) 
! 
!         IF ( INFO>0 ) THEN 
!           WRITE(*,*) 'A IS SINGULAR for LU (that is LU factorization using partial' 
!           WRITE(*,*) ' pivoting with row interchanges is an unstable method for current A) ' 
!           write(*,*) ' so DGETRS will be no applied.' 
!!           STOP 
!         ELSE 
! 
! 
!         CALL DGETRS( 'N', PNRWBLK*(PNBLOKS+1), 1, A, PNRWBLK*(PNBLOKS+1), & 
!                 IPIV, XTEO, PNRWBLK*(PNBLOKS+1), INFO ) 
! 
!         ENDIF 
!!! 
! 
! 
!         CALL PARABABDCR_MAIN(VECT_B=B, INFO=INFO) 
!!         write(*,*) 'computed X= ', B 
!         write(*,*) 'maxval( abs(1- computed X))', MAXVAL(ABS(1-B)) 
!!         write(*,*) 'XTEO from dgetrf/dgetrs =', XTEO 
! 
!!! control of solution 
!         IF (INFO.EQ.0) THEN 
!           ERROR= MAXVAL( ABS( B-XTEO ) ) 
!           WRITE(*,*) 'NRWBLK= ',PNRWBLK,'    NBLOKS= ',PNBLOKS 
!           WRITE(*,*) 'MAX ABS ERROR= ', ERROR 
!         ENDIF 
!           DEALLOCATE(A, XTEO, IPIV) 
!!! 
! 
!         DEALLOCATE(B) 
! 
!       ENDIF 
! 
!      CASE ('3') 
!        IF (ALLOCATED(B))  DEALLOCATE (B, XTEO, IPIV ) 
!        IF (ALLOCATED(PMATR_A)) DEALLOCATE(PMATR_A, PFILL_IN, PPERM, MATR) 
! 
!    END SELECT 
! 
!   ENDDO 
!!!!!!!!!!!!!!!!!!1 
